# ======  getFigs4.6.7_ChIPchipMethod.R

source("common_functions_MA.R")
source("common_functions.R")

#------------- load data -----

#load("A.o_matrix.RData")
#load("M.o_matrix.RData")
#colnames(A.o)

A.o <- A.o[,11:14]
M.o <- M.o[,11:14]

#A.o <-  round(A.o,2)
#M.o <-  round(M.o,2)

#save(A.o, file="A.o.RData")
#save(M.o, file="M.o.RData")
load("A.o.RData")
load("M.o.RData")

rownames(A.o)[1:5]
names(index.X.F)

load("index.RData")

ind.exp <- seq(1,4,2)
ind.bkg <- seq(2,4,2)

colnames(M.o)


#=============== normalizing all the MSL3-TAP ChIP-chip data =======
f.out=2;iteration=3;lag=8
#=========================

M.o.exp <- M.o[,ind.exp]; M.o.bkg <- M.o[,ind.bkg]
A.o.exp <- A.o[,ind.exp]; A.o.bkg <- A.o[,ind.bkg]

#------ embryos data: 2 replicates ---

help.search("ppp")
library(MASS)
library(spatstat)

ii=1;    #Emb replicate #1
#ii=2;    #Emb replicate #2

lim.M	<- range(M.o.exp[,ii],M.o.bkg[,ii])  # Emb_1

MA.o.exp <- ppp(A.o.exp[,ii],M.o.exp[,ii])
MA.o.bkg <- ppp(A.o.bkg[,ii],M.o.bkg[,ii])
MA  <- ppp(M.o.bkg[,ii],M.o.exp[,ii])

#----------- Scatter Plot for Chr.X and Chr.2L together
#png(file.path(FiguresDir, paste(fn.sc,".png",sep="")));
sample=size=20000

plotMA(A=M.o.bkg[,ii],M=M.o.exp[,ii],pch=".",xlab="Mock Control",ylab="Experiment",
	xlim = lim.M, ylim = lim.M,sample=NULL,main="")
abline(0,1,lty=2, lw=2, col="cyan")

#--------------------------------------------------------
# Fig.4. Misalignment b/t ChIP-chip and Mock data 
#------ select one region in MA  to show misalignment ---
library(MASS)
library(spatstat)

lim.M	<- range(M.o.exp[,ii],M.o.bkg[,ii])  # Emb_1

MA.o.exp <- ppp(A.o.exp[,ii],M.o.exp[,ii])
MA.o.bkg <- ppp(A.o.bkg[,ii],M.o.bkg[,ii])
#MA  <- ppp(M.o.bkg[,ii],M.o.exp[,ii])

A=MA.o.exp$x;M=MA.o.exp$y
par(mfrow=c(2,2))
plotMA(A=A,M=M,sample=sample)
A0 <- round(median(A),1)  #10.9
M0 <- round(median(M),1)  #0
ind.X.s <- index.X.F; ind.2L.s <- index.2L.F
length(ind.0	<- which(((M-M0)^2+(A-A0)^2)<0.04)); ind.part0 <- intersect(ind.0,union(ind.X.s,ind.2L.s))
length(ind.part0)
sample

ind.part <- ind.s <- ind.part0; main="ChIP-chip"

plotMA(M=M.o.exp[,ii],A=A.o.exp[,ii],sample=sample,main=main)
points(A.o.exp[ind.part,ii],M.o.exp[ind.part,ii],col="green",pch=".")
abline(h=0,col="cyan",lty=2,lw=2)

plotMA(M=M.o.bkg[,ii],A=A.o.bkg[,ii],sample=sample,main=main)
points(A.o.bkg[ind.part,ii],M.o.bkg[ind.part,ii],col="green",pch=".")
abline(h=0,col="cyan",lty=2,lw=2)

#=======================================================
# Fig.6 Procedure of Rotation & Lowess Normalization
#--------------------------------------------------------------

f.out <- 2; iteration=3; lag=8
get.MA.rl

MA.rl <- get.MA.rl(MA.o.exp,f.out,iteration,lag)
MA   <- MA.rl$MA
MA.r <- MA.rl$MA.r
rMA  <- MA.r$MA
fit  <- MA.rl$fit
MA.lowess <- MA.rl$MA.l

weights <- set.weights(rMA$y,f.out)
fit_0.20 <- loess(rMA$y ~ rMA$x, span = 0.2, degree = 1,
               surface = "interpolate", family = "symmetric",
               trace.hat = "approximate", iterations = 4,
               weights=weights)
fit_0.30 <- loess(rMA$y ~ rMA$x, span = 0.3, degree = 1,
               surface = "interpolate", family = "symmetric",
               trace.hat = "approximate", iterations = 4,
               weights=weights)
fit_0.40 <- loess(rMA$y ~ rMA$x, span = 0.4, degree = 1,
               surface = "interpolate", family = "symmetric",
               trace.hat = "approximate", iterations = 4,
               weights=weights)
sample=3000
if (is.null(sample)){
  print(sample)
  ind <- union(index.X.F,index.2L.F)
}else{
  ind <- union(sample(index.X.F,size=sample),sample(index.2L.F,size=sample))
}

#----------
par(mfrow=c(2,2))
sample = 3000; main =""
plotMA(sample=sample,M=MA$y, A=MA$x, main=main)
abline(h=0,lty=2,col="cyan",lw=2)

d.M <- diff(MA$y,lag=lag); d.A <- diff(MA$x,lag=lag);lim <- range(c(d.M,d.A))
xlab= expression(sigma(A))
ylab= expression(sigma(M))
plotMA(sample=sample,M=d.M, A=d.A,xlim=lim,ylim=lim,
       xlab=xlab, ylab=ylab, main="")
#       xlab="lagged diff. of A", ylab ="lagged diff. of M", main="")
b <- -tan(MA.r$angle)
abline(a=0,b=b,lty=2,col="green",lw=2)
abline(h=0,lty=2,col="cyan",lw=2)

plotMA(sample=sample,M=rMA$y, A=rMA$x, main=main)
points(rMA$x[ind],fit$fitted[ind],pch=".",col="green")

points(rMA$x[ind],fit_0.20$fitted[ind],pch=".",col="purple")
#points(rMA$x[ind],fit_0.30$fitted[ind],pch=".",col="purple")
points(rMA$x[ind],fit_0.40$fitted[ind],pch=".",col="grey")

(angles <- paste(as.numeric(round(MA.r$angles*4/pi,2)), collapse="; "))
#legend <- paste("Angle: ", round(MA.r$angle*4/pi,2), " [",angles,"]","*pi/4", sep="")
#  legend("topleft",legend=legend,text.col=1,cex=cex)
abline(h=0,lty=2,col="cyan",lw=2)

#--------------

#plotMA(sample=sample,M=rMA$y, A=rMA$x, main=main)
#points(rMA$x[ind],fit$fitted[ind],pch=".",col="green")

text.col=c("purple","green","grey")
(legend <- paste("Span: ",c("20%", "30%", "40%"),sep=""))
points(rMA$x[ind],fit_0.20$fitted[ind],pch=".",col=text.col[1])
points(rMA$x[ind],fit_0.40$fitted[ind],pch=".",col=text.col[3])
points(rMA$x[ind],fit_0.30$fitted[ind],pch=".",col=text.col[2])

(angles <- paste(as.numeric(round(MA.r$angles*4/pi,2)), collapse="; "))
#legend <- paste("Angle: ", round(MA.r$angle*4/pi,2), " [",angles,"]","*pi/4", sep="")

legend("topleft",legend=legend,text.col=text.col,cex=1)

abline(h=0,lty=2,col="cyan",lw=2)

plotMA(sample=sample,A=MA.lowess$x,M=MA.lowess$y,main=main)
#  legend=paste("Zero weight for outliers (", f.out,"*sd)", sep="");legend("topleft",legend=legend,text.col=1,cex=cex)
#abline(h=0,lty=2,col="cyan")
abline(h=0,col="green",lw=2)

#===========================================
# Fig.7	Effect of normalization
#===========================================

MA.rl.exp <- get.MA.rl(MA.o.exp)
MA.rl.bkg <- get.MA.rl(MA.o.bkg)

M.rl <- cbind(MA.rl.bkg$MA.l$y,MA.rl.exp$MA.l$y)

lim.M	<- range(M.o.exp[,ii],M.o.bkg[,ii])  # Emb_1

#----------

xlim.rl <- ylim.rl <- c(-2,5)

#----------- Scatter Plot for Chr.X and Chr.2L together

size <- 10000
print(sample <- size)
plotMA(A=M.rl[,1],M=M.rl[,2],pch=".",xlab="Mock Control",ylab="Experiment",
	xlim = xlim.rl, ylim = ylim.rl,main="",sample=sample)

#----------- Scatter Plot for Chr.X and Chr.2L together after smoothing
plotMA(A=sm(M.rl[,1]),M=sm(M.rl[,2]),pch=".",xlab="Mock Control",ylab="Experiment",
	xlim = xlim.rl, ylim = ylim.rl,main="",sample=sample)
abline(0,1,lty=2,col="cyan",lw=2)

h <-   2.5*mad.diff_lag((M.rl[,2]))
abline(h=h,lty=2,col=1,lw=2)
